# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 824 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/_mklbtype.al)"
sub _mklbtype {
  my ($ntype, @cmt) = @_;
  my $rep;
  GetOptions('replace' => \$rep);
  $ct = ClearCase::Argv->new({autochomp=>1});
  my @args = $ntype->args;
  my %opt = %{$ntype->{fopts}};
  my $silent = $ct->clone;
  $silent->stdout(0);
  if (!%opt and my ($ahl) = grep /^->/,
      $ct->desc([qw(-s -ahl AdminVOB vob:.)])->qx) {
    if (my $avob = (split /\s+/, $ahl)[1]) {
      for (@args) {
	next if /\@/;
	$_ = "$_\@$avob";
	warn Msg('W', "making global type $_ ...");
      }
      $ntype->args(@args);
      my @opts = (@cmt, '-global', $ntype->opts);
      push @opts, '-replace' if $rep;
      $ntype->opts(@opts);
      return $ntype->system;
    }
  } elsif (%opt) {
    map { s/^lbtype:(.*)$/$1/ } @args;
    my @a = @args;
    my @vob = grep { s/.*\@(.*)$/$1/ } @a;
    push @vob, $ct->argv(qw(des -s vob:.))->stderr(0)->qx
      if grep !/@/, @args;
    die  Msg('E', qq(Unable to determine VOB for pathname ".".\n))
      unless @vob;
    ensuretypes(@vob);
    if ($rep) {
      @args = grep { $ct->argv(qw(des -fmt), '%Xn', "lbtype:$_")->qx } @args;
      exit 1 unless @args;
      if ($opt{family}) {
	@a = ();
	foreach my $t (@args) {
	  if ($ct->argv(qw(des -s -ahl), $eqhl, $t)->stderr(0)->qx) {
	    warn Msg('E', "$t is already a family type\n");
	  } else {
	    push @a, $t;
	  }
	}
	exit 1 unless @a;
	my %pair = ();
	foreach (@a) {
	  if (/^lbtype:(.*)(@.*)$/) {
	    $pair{"$1$2"} = "${1}_1.00$2";
	  }
	}
	findfreeinc(\%pair);
	$ntype->args(values %pair);
	$ntype->opts(@cmt, $ntype->opts);
	$ntype->system;
	map {
	  if (defined($pair{$_})) {
	    my $inc = "lbtype:$pair{$_}";
	    $silent->argv('mkhlink', $eqhl, "lbtype:$_", $inc)->system;
	  }
	} keys %pair;
      } else {			# increment
	die Msg('E', "Incompatible flags: replace and incremental");
      }
    } else {
      if ($opt{family}) {
	map { $_ = "lbtype:$_" } @a;
	die Msg('E', "Some types already exist among @args")
	  unless $silent->argv(qw(des -s), @a)->stderr(0)->system;
	my %pair = ();
	foreach (@args) {
	  if (/^(.*?)(@.*)?$/) {
	    $pair{$_} = "${1}_1.00" . ($2? $2:'');
	  }
	}
	findfreeinc(\%pair);
	my @opts = $ntype->opts();
	$ntype->args(values %pair);
	$ntype->opts(@cmt, @opts);
	$ntype->system;
	$ntype->args(@args);
	$ntype->opts('-nc', @opts);
	$ntype->system;
	map {
	  if (defined($pair{$_})) {
	    my $inc = "lbtype:$pair{$_}";
	    $silent->argv('mkhlink', $eqhl, "lbtype:$_", $inc)->system;
	  }
	} keys %pair;
      } elsif ($opt{increment}) { # increment
	for my $t (@args) {
	  die
	    Msg('E',
		"Lock on label type \"$t\" prevents operation \"make lbtype\"")
	      if $ct->argv(qw(lslock -s),"lbtype:$t")->stderr(0)->qx;
	  my ($pair) = grep s/^\s*(.*) -> lbtype:(.*)\@(.*)$/$1,$2,$3/,
	    $ct->argv(qw(des -l -ahl), $eqhl, "lbtype:$t")->stderr(0)->qx;
	  my ($hlk, $prev, $vob) = split ',', $pair if $pair;
	  next unless $prev;
	  if ($prev =~ /^(.*)_(\d+)(?:\.(\d+))?$/) {
	    my ($base, $maj, $min) = ($1, $2, $3);
	    my $new = "${base}_" .
	      (defined($min)? $maj . '.' . ++$min : ++$maj);
	    map { $_ .= $1 } ($new, $prev) if $t =~ /^.*(@.*)$/;
	    $ntype->opts(@cmt, $ntype->opts);
	    $ntype->args($new)->system;
	    $silent->argv('rmhlink', $hlk)->system;
	    $silent->argv(qw(mkhlink -nc), $eqhl,
			  "lbtype:$t", "lbtype:$new")->system;
	    $silent->argv(qw(mkhlink -nc), $prhl,
			  "lbtype:$new", "lbtype:$prev")->system;
	  } else {
	    warn "Previous increment non suitable in $t: $prev\n";
	    next;
	  }
	}
      } else {
	die Msg('E', 'Not implemented yet');
      }
    }
    exit 0;
  } else {			# non inc
    if ($rep) {
      $ntype->opts(@cmt, '-replace', $ntype->opts);
      map { $_ = "lbtype:$_" unless /^lbtype:/ } @args;
      my @a = $ct->argv(qw(des -s), @args)->stderr(0)->qx;
      if (@a) {
	map { $_ = "lbtype:$_" } @a;
	my @link = grep s/^\s*(.*) -> .*$/$1/,
	  $ct->argv(qw(des -l -ahl), "$eqhl,$prhl", @a)->qx;
	$ct->argv('rmhlink', @link)->system;
      }
    } else {
      $ntype->opts(@cmt, $ntype->opts);
      return $ntype->system;
    }
  }
}

# end of ClearCase::Wrapper::MGi::_mklbtype
1;
